---
title: Read promotion steps
description: Return the promotion plan operations, including the payload for each step, for the specified PingOne promotion
component: pingone-api
page_id: pingone-api:platform:configuration-management/promotions/get-promotion-steps
canonical_url: https://developer.pingidentity.com/pingone-api/platform/configuration-management/promotions/get-promotion-steps.html
llms_txt: https://developer.pingidentity.com/pingone-api/llms.txt
docs_for_agents: https://developer.pingidentity.com/build-with-ai/docs-for-agents.md
revdate: 2026-05-05
section_ids:
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Read promotion steps

##

```none
GET {{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3
```

Use the GET `{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps` request to return the operations used for a promotion plan, including the payload for each operation. Refer to [Read One Promotion](get-one-promotion.html) to get information about the promotion.

The process of promoting a resource or resources from a source environment to a target environment involves calling PingOne APIs to perform the operations in the target environment. These are the promotion steps returned.

Pagination is supported for response using the query parameters.

> **Collapse: Query parameters**
>
> | Parameter         | Description                                                           |
> | ----------------- | --------------------------------------------------------------------- |
> | `count` or `size` | Indicates the number of items returned in the current page.           |
> | `cursor`          | Indicates the first item to retrieve.                                 |
> | `limit`           | Indicates the number of steps to be returned per page.                |
> | `next`            | Indicates the cursor to be used to retrieve the next page of results. |

### Headers

Authorization      Bearer {{accessToken}}

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3 HTTP/1.1
Host: {{apiPath}}
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3")
  .method("GET", body)
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3",
  "method": "GET",
  "timeout": 0,
  "headers": {
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3',
  'headers': {
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3"

payload = {}
headers = {
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}/promotionSteps?cursor=3&limit=3")!,timeoutInterval: Double.infinity)
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
  "_links": {
    "prev": {
      "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/58b5aeab-643c-4e5f-bd7c-463fd6cd66be/promotionSteps?limit=3&cursor=0"
    },
    "self": {
      "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/58b5aeab-643c-4e5f-bd7c-463fd6cd66be/promotionSteps?limit=3&cursor=3"
    }
  },
  "_embedded": {
    "promotionSteps": [
      {
        "number": 4,
        "action": "POST",
        "origin": "EVALUATED_AS_REQUIRED",
        "executionStatus": "READY",
        "resourceUrl": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/df299e47-59a8-4125-82c9-ec8d3e9df315/actions",
        "sourceResource": {
          "name": "signonpolicies:actions:f3dd899a-a0c7-4a1b-9dd0-46ce9b91ccd3",
          "id": "f3dd899a-a0c7-4a1b-9dd0-46ce9b91ccd3"
        },
        "payload": {
          "environment": {
            "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
          },
          "condition": {
            "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}",
            "greater": 1800
          },
          "hidden": false,
          "signOnPolicy": {
            "id": "df299e47-59a8-4125-82c9-ec8d3e9df315"
          },
          "registration": {
            "enabled": false
          },
          "id": "f3dd899a-a0c7-4a1b-9dd0-46ce9b91ccd3",
          "recovery": {
            "enabled": true
          },
          "type": "LOGIN",
          "priority": 1
        },
        "totalDistance": 100.0,
        "required": true
      },
      {
        "number": 5,
        "action": "POST",
        "origin": "EVALUATED_AS_REQUIRED",
        "executionStatus": "READY",
        "resourceUrl": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/applications/4e3f1ff5-e15e-4585-a0a3-943cde0d4c76/signOnPolicyAssignments",
        "sourceResource": {
          "name": "applications:signonpolicyassignments:6b475594-2c28-4627-acf5-e196fdc4d2eb",
          "id": "6b475594-2c28-4627-acf5-e196fdc4d2eb"
        },
        "payload": {
          "environment": {
            "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
          },
          "application": {
            "id": "4e3f1ff5-e15e-4585-a0a3-943cde0d4c76"
          },
          "signOnPolicy": {
            "id": "df299e47-59a8-4125-82c9-ec8d3e9df315"
          },
          "id": "6b475594-2c28-4627-acf5-e196fdc4d2eb",
          "priority": 1
        },
        "totalDistance": 100.0,
        "required": true
      }
    ]
  },
  "count": 5,
  "size": 2
}
```
